osgParticle::ParticleEffect Class Referenceabstract

`#include <ParticleEffect>`

Inheritance diagram for osgParticle::ParticleEffect:

## Public Member Functions

| ParticleEffect (bool automaticSetup=true)
| ParticleEffect (const ParticleEffect &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual void | accept (osg::NodeVisitor &nv)
void | setAutomaticSetup (bool flag)
bool | getAutomaticSetup () const
void | setUseLocalParticleSystem (bool local)
bool | getUseLocalParticleSystem () const
void | setTextureFileName (const std::string &filename)
const std::string & | getTextureFileName () const
void | setDefaultParticleTemplate (const Particle &p)
const Particle & | getDefaultParticleTemplate () const
void | setPosition (const osg::Vec3 &position)
const osg::Vec3 & | getPosition () const
void | setScale (float scale)
float | getScale () const
void | setIntensity (float intensity)
float | getIntensity () const
void | setStartTime (double startTime)
double | getStartTime () const
void | setEmitterDuration (double duration)
double | getEmitterDuration () const
void | setParticleDuration (double duration)
double | getParticleDuration () const
void | setWind (const osg::Vec3 &wind)
const osg::Vec3 & | getWind () const
bool | areAllParticlesDead () const
| Get whether all particles are dead.
virtual Emitter * | getEmitter ()=0
virtual const Emitter * | getEmitter () const =0
virtual Program * | getProgram ()=0
virtual const Program * | getProgram () const =0
void | setParticleSystem (ParticleSystem *ps)
template<class T>
void | setParticleSystem (const osg::ref_ptr< T > &ri)
ParticleSystem * | getParticleSystem ()
const ParticleSystem * | getParticleSystem () const
virtual void | setDefaults ()
virtual void | setUpEmitterAndProgram ()=0
virtual void | buildEffect ()
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ParticleEffect ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

bool | _automaticSetup
osg::ref_ptr< ParticleSystem > | _particleSystem
bool | _useLocalParticleSystem
std::string | _textureFileName
Particle | _defaultParticleTemplate
osg::Vec3 | _position
float | _scale
float | _intensity
double | _startTime
double | _emitterDuration
osg::Vec3 | _wind
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Constructor & Destructor Documentation

## ParticleEffect() [1/2]

osgParticle::ParticleEffect::ParticleEffect | ( | bool | automaticSetup = true | ) |

inline explicit

References _automaticSetup, _emitterDuration, _intensity, _scale, _startTime, _useLocalParticleSystem, and _wind.

Referenced by isSameKindAs(), and ParticleEffect().

## ParticleEffect() [2/2]

osgParticle::ParticleEffect::ParticleEffect | ( | const ParticleEffect & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References ParticleEffect(), and osg::CopyOp::SHALLOW_COPY.

## ~ParticleEffect()

virtual osgParticle::ParticleEffect::~ParticleEffect | ( |  | ) |

inline protected virtual

## Member Function Documentation

## accept()

virtual void osgParticle::ParticleEffect::accept | ( | osg::NodeVisitor & | nv | ) |

inline virtual

Visitor Pattern : calls the apply method of a NodeVisitor with this node's type.

Reimplemented from osg::Node.

References osg::NodeVisitor::apply(), osg::NodeVisitor::popFromNodePath(), osg::NodeVisitor::pushOntoNodePath(), and osg::NodeVisitor::validNodeMask().

## areAllParticlesDead()

bool osgParticle::ParticleEffect::areAllParticlesDead | ( |  | ) | const

inline

Get whether all particles are dead.

References _particleSystem.

## buildEffect()

virtual void osgParticle::ParticleEffect::buildEffect | ( |  | ) |

virtual

## className()

virtual const char * osgParticle::ParticleEffect::className | ( |  | ) | const

inline virtual

return the name of the node's class type.

Reimplemented from osg::Node.

## getAutomaticSetup()

bool osgParticle::ParticleEffect::getAutomaticSetup | ( |  | ) | const

inline

References _automaticSetup.

## getDefaultParticleTemplate()

const Particle & osgParticle::ParticleEffect::getDefaultParticleTemplate | ( |  | ) | const

inline

References _defaultParticleTemplate.

## getEmitter() [1/2]

virtual const Emitter * osgParticle::ParticleEffect::getEmitter | ( |  | ) | const

pure virtual

Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

## getEmitter() [2/2]

virtual Emitter * osgParticle::ParticleEffect::getEmitter | ( |  | ) |

pure virtual

Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

## getEmitterDuration()

double osgParticle::ParticleEffect::getEmitterDuration | ( |  | ) | const

inline

References _emitterDuration.

## getIntensity()

float osgParticle::ParticleEffect::getIntensity | ( |  | ) | const

inline

References _intensity.

## getParticleDuration()

double osgParticle::ParticleEffect::getParticleDuration | ( |  | ) | const

inline

References _defaultParticleTemplate.

## getParticleSystem() [1/2]

ParticleSystem * osgParticle::ParticleEffect::getParticleSystem | ( |  | ) |

inline

References _particleSystem.

## getParticleSystem() [2/2]

const ParticleSystem * osgParticle::ParticleEffect::getParticleSystem | ( |  | ) | const

inline

References _particleSystem.

## getPosition()

const osg::Vec3 & osgParticle::ParticleEffect::getPosition | ( |  | ) | const

inline

References _position.

## getProgram() [1/2]

virtual const Program * osgParticle::ParticleEffect::getProgram | ( |  | ) | const

pure virtual

Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

## getProgram() [2/2]

virtual Program * osgParticle::ParticleEffect::getProgram | ( |  | ) |

pure virtual

Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

## getScale()

float osgParticle::ParticleEffect::getScale | ( |  | ) | const

inline

References _scale.

## getStartTime()

double osgParticle::ParticleEffect::getStartTime | ( |  | ) | const

inline

References _startTime.

## getTextureFileName()

const std::string & osgParticle::ParticleEffect::getTextureFileName | ( |  | ) | const

inline

References _textureFileName.

## getUseLocalParticleSystem()

bool osgParticle::ParticleEffect::getUseLocalParticleSystem | ( |  | ) | const

inline

References _useLocalParticleSystem.

## getWind()

const osg::Vec3 & osgParticle::ParticleEffect::getWind | ( |  | ) | const

inline

References _wind.

## isSameKindAs()

virtual bool osgParticle::ParticleEffect::isSameKindAs | ( | const osg::Object * | obj | ) | const

inline virtual

return true if this and obj are of the same kind of object.

Reimplemented from osg::Node.

References ParticleEffect().

## libraryName()

virtual const char * osgParticle::ParticleEffect::libraryName | ( |  | ) | const

inline virtual

return the name of the node's library.

Reimplemented from osg::Node.

## setAutomaticSetup()

void osgParticle::ParticleEffect::setAutomaticSetup | ( | bool | flag | ) |

inline

References _automaticSetup.

## setDefaultParticleTemplate()

void osgParticle::ParticleEffect::setDefaultParticleTemplate | ( | const Particle & | p | ) |

## setDefaults()

virtual void osgParticle::ParticleEffect::setDefaults | ( |  | ) |

virtual

Reimplemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

## setEmitterDuration()

void osgParticle::ParticleEffect::setEmitterDuration | ( | double | duration | ) |

## setIntensity()

void osgParticle::ParticleEffect::setIntensity | ( | float | intensity | ) |

## setParticleDuration()

void osgParticle::ParticleEffect::setParticleDuration | ( | double | duration | ) |

## setParticleSystem() [1/2]

template<class T>

void osgParticle::ParticleEffect::setParticleSystem | ( | const osg::ref_ptr< T > & | ri | ) |

inline

References osg::ref_ptr< T >::get(), and setParticleSystem().

Referenced by setParticleSystem().

## setParticleSystem() [2/2]

void osgParticle::ParticleEffect::setParticleSystem | ( | ParticleSystem * | ps | ) |

## setPosition()

void osgParticle::ParticleEffect::setPosition | ( | const osg::Vec3 & | position | ) |

## setScale()

void osgParticle::ParticleEffect::setScale | ( | float | scale | ) |

## setStartTime()

void osgParticle::ParticleEffect::setStartTime | ( | double | startTime | ) |

## setTextureFileName()

void osgParticle::ParticleEffect::setTextureFileName | ( | const std::string & | filename | ) |

## setUpEmitterAndProgram()

virtual void osgParticle::ParticleEffect::setUpEmitterAndProgram | ( |  | ) |

pure virtual

Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

## setUseLocalParticleSystem()

void osgParticle::ParticleEffect::setUseLocalParticleSystem | ( | bool | local | ) |

## setWind()

void osgParticle::ParticleEffect::setWind | ( | const osg::Vec3 & | wind | ) |

## Member Data Documentation

## _automaticSetup

bool osgParticle::ParticleEffect::_automaticSetup

protected

Referenced by getAutomaticSetup(), ParticleEffect(), and setAutomaticSetup().

## _defaultParticleTemplate

Particle osgParticle::ParticleEffect::_defaultParticleTemplate

protected

Referenced by getDefaultParticleTemplate(), and getParticleDuration().

## _emitterDuration

double osgParticle::ParticleEffect::_emitterDuration

protected

Referenced by getEmitterDuration(), and ParticleEffect().

## _intensity

float osgParticle::ParticleEffect::_intensity

protected

Referenced by getIntensity(), and ParticleEffect().

## _particleSystem

osg::ref_ptr<ParticleSystem> osgParticle::ParticleEffect::_particleSystem

protected

Referenced by areAllParticlesDead(), getParticleSystem(), and getParticleSystem().

## _position

osg::Vec3 osgParticle::ParticleEffect::_position

protected

Referenced by getPosition().

## _scale

float osgParticle::ParticleEffect::_scale

protected

Referenced by getScale(), and ParticleEffect().

## _startTime

double osgParticle::ParticleEffect::_startTime

protected

Referenced by getStartTime(), and ParticleEffect().

## _textureFileName

std::string osgParticle::ParticleEffect::_textureFileName

protected

Referenced by getTextureFileName().

## _useLocalParticleSystem

bool osgParticle::ParticleEffect::_useLocalParticleSystem

protected

Referenced by getUseLocalParticleSystem(), and ParticleEffect().

## _wind

osg::Vec3 osgParticle::ParticleEffect::_wind

protected

Referenced by getWind(), and ParticleEffect().

The documentation for this class was generated from the following file:

- ParticleEffect